NNG_HTTP_CONN_READ_ALL(3http)

NAME
nng_http_conn_read_all - read all from HTTP connection

SYNOPSIS

    #include <nng/nng.h>
    #include <nng/supplemental/http/http.h>
    void nng_http_conn_read_all(nng_http_conn *conn, nng_aio *aio);

DESCRIPTION

The nng_http_conn_read_all() function starts an asynchronous read from the HTTP connection conn, into the scatter/gather vector located in the asynchronous I/O structure aio.

    Note

    The nng_aio_set_iov() function must have been called first, to set the scatter/gather vector for aio.

This function returns immediately, with no return value. Completion of the operation is signaled via the aio, and the final result may be obtained via nng_aio_result(). That result will either be zero or an error code.

The I/O operation completes only when the entire amount of data requested has been read, or an error has occurred. If the operation completes successfully, then the entire requested data has been read.

It is still possible for a partial read to complete in the event of an error. The actual number of bytes read can be determined with nng_aio_count().

    Tip

    The main purpose for this function is to facilitate reading HTTP body content, after first determining the length of the body content from the relevant HTTP headers (typically Content-Length).

RETURN VALUES

None.

ERRORS

NNG_ECANCELED
    The operation was canceled.

NNG_ECLOSED
    The connection was closed.

NNG_ECONNRESET
    The peer closed the connection.

NNG_EINVAL
    The aio does not contain a valid scatter/gather vector.

NNG_ENOMEM
    Insufficient free memory to perform the operation.

NNG_ENOTSUP
    HTTP operations are not supported.

NNG_ETIMEDOUT
    Timeout waiting for data from the connection.

SEE ALSO

nng_aio_alloc(3), nng_aio_count(3), nng_aio_result(3), nng_aio_set_iov(3), nng_strerror(3), nng_http_client_connect(3), nng_http_conn_read(3), nng(7)